Index: trunk/src/lib/util/sigslot/slot.h
===================================================================
--- trunk/src/lib/util/sigslot/slot.h	(revision 9406)
+++ trunk/src/lib/util/sigslot/slot.h	(revision 9406)
@@ -0,0 +1,307 @@
+/**
+ * @file slot.h
+ * @brief Slots part of Signal Slot library from Sarah Thopson
+ * @see signal.h for more information and license.
+ */
+
+#ifndef SLOT_H__
+#define SLOT_H__
+
+#include <set>
+#include <list>
+
+
+#if defined(SIGSLOT_PURE_ISO) || (!defined(WIN32) && !defined(__GNUG__) && !defined(SIGSLOT_USE_POSIX_THREADS))
+#	define _SIGSLOT_SINGLE_THREADED
+#elif defined(WIN32)
+#	define _SIGSLOT_HAS_WIN32_THREADS
+#	include <windows.h>
+#elif defined(__GNUG__) || defined(SIGSLOT_USE_POSIX_THREADS)
+#	define _SIGSLOT_HAS_POSIX_THREADS
+#	include <pthread.h>
+#else
+#	define _SIGSLOT_SINGLE_THREADED
+#endif
+
+#ifndef SIGSLOT_DEFAULT_MT_POLICY
+#	ifdef _SIGSLOT_SINGLE_THREADED
+#		define SIGSLOT_DEFAULT_MT_POLICY single_threaded
+#	else
+#		define SIGSLOT_DEFAULT_MT_POLICY multi_threaded_local
+#	endif
+#endif
+
+namespace sigslot
+{
+
+  class single_threaded
+  {
+    public:
+      single_threaded()
+      {
+        ;
+      }
+
+      virtual ~single_threaded()
+      {
+        ;
+      }
+
+      virtual void lock()
+      {
+        ;
+      }
+
+      virtual void unlock()
+      {
+        ;
+      }
+  };
+
+#ifdef _SIGSLOT_HAS_WIN32_THREADS
+  // The multi threading policies only get compiled in if they are enabled.
+  class multi_threaded_global
+  {
+    public:
+      multi_threaded_global()
+      {
+        static bool isinitialised = false;
+
+        if(!isinitialised)
+        {
+          InitializeCriticalSection(get_critsec());
+          isinitialised = true;
+        }
+      }
+
+      multi_threaded_global(const multi_threaded_global&)
+      {
+        ;
+      }
+
+      virtual ~multi_threaded_global()
+      {
+        ;
+      }
+
+      virtual void lock()
+      {
+        EnterCriticalSection(get_critsec());
+      }
+
+      virtual void unlock()
+      {
+        LeaveCriticalSection(get_critsec());
+      }
+
+    private:
+      CRITICAL_SECTION* get_critsec()
+      {
+        static CRITICAL_SECTION g_critsec;
+        return &g_critsec;
+      }
+  };
+
+  class multi_threaded_local
+  {
+    public:
+      multi_threaded_local()
+      {
+        InitializeCriticalSection(&m_critsec);
+      }
+
+      multi_threaded_local(const multi_threaded_local&)
+      {
+        InitializeCriticalSection(&m_critsec);
+      }
+
+      virtual ~multi_threaded_local()
+      {
+        DeleteCriticalSection(&m_critsec);
+      }
+
+      virtual void lock()
+      {
+        EnterCriticalSection(&m_critsec);
+      }
+
+      virtual void unlock()
+      {
+        LeaveCriticalSection(&m_critsec);
+      }
+
+    private:
+      CRITICAL_SECTION m_critsec;
+  };
+#endif // _SIGSLOT_HAS_WIN32_THREADS
+
+#ifdef _SIGSLOT_HAS_POSIX_THREADS
+  // The multi threading policies only get compiled in if they are enabled.
+  class multi_threaded_global
+  {
+    public:
+      multi_threaded_global()
+      {
+        pthread_mutex_init(get_mutex(), NULL);
+      }
+
+      multi_threaded_global(const multi_threaded_global&)
+      {
+        ;
+      }
+
+      virtual ~multi_threaded_global()
+      {
+        ;
+      }
+
+      virtual void lock()
+      {
+        pthread_mutex_lock(get_mutex());
+      }
+
+      virtual void unlock()
+      {
+        pthread_mutex_unlock(get_mutex());
+      }
+
+    private:
+      pthread_mutex_t* get_mutex()
+      {
+        static pthread_mutex_t g_mutex;
+        return &g_mutex;
+      }
+  };
+
+  class multi_threaded_local
+  {
+    public:
+      multi_threaded_local()
+      {
+        pthread_mutex_init(&m_mutex, NULL);
+      }
+
+      multi_threaded_local(const multi_threaded_local&)
+      {
+        pthread_mutex_init(&m_mutex, NULL);
+      }
+
+      virtual ~multi_threaded_local()
+      {
+        pthread_mutex_destroy(&m_mutex);
+      }
+
+      virtual void lock()
+      {
+        pthread_mutex_lock(&m_mutex);
+      }
+
+      virtual void unlock()
+      {
+        pthread_mutex_unlock(&m_mutex);
+      }
+
+    private:
+      pthread_mutex_t m_mutex;
+  };
+#endif // _SIGSLOT_HAS_POSIX_THREADS
+
+  template<class mt_policy>
+  class lock_block
+  {
+    public:
+      mt_policy *m_mutex;
+
+      lock_block(mt_policy *mtx)
+          : m_mutex(mtx)
+      {
+        m_mutex->lock();
+      }
+
+      ~lock_block()
+      {
+        m_mutex->unlock();
+      }
+  };
+
+
+
+
+  template<class mt_policy>
+  class has_slots;
+
+
+  template<class mt_policy>
+  class _signal_base : public mt_policy
+  {
+    public:
+      virtual void slot_disconnect(has_slots<mt_policy>* pslot) = 0;
+      virtual void slot_duplicate(const has_slots<mt_policy>* poldslot, has_slots<mt_policy>* pnewslot) = 0;
+  };
+
+  template<class mt_policy = SIGSLOT_DEFAULT_MT_POLICY>
+  class has_slots //: public mt_policy
+  {
+    private:
+      typedef std::set<_signal_base<mt_policy> *> sender_set;
+      typedef typename sender_set::const_iterator const_iterator;
+
+    public:
+      has_slots()
+      {
+        ;
+      }
+
+      has_slots(const has_slots& hs)
+//          : mt_policy(hs)
+      {
+        //lock_block<mt_policy> lock(this);
+        const_iterator it = hs.m_senders.begin();
+        const_iterator itEnd = hs.m_senders.end();
+
+        while(it != itEnd)
+        {
+          (*it)->slot_duplicate(&hs, this);
+          m_senders.insert(*it);
+          ++it;
+        }
+      }
+
+      void signal_connect(_signal_base<mt_policy>* sender)
+      {
+        //lock_block<mt_policy> lock(this);
+        m_senders.insert(sender);
+      }
+
+      void signal_disconnect(_signal_base<mt_policy>* sender)
+      {
+        //lock_block<mt_policy> lock(this);
+        m_senders.erase(sender);
+      }
+
+      virtual ~has_slots()
+      {
+        disconnect_all();
+      }
+
+      void disconnect_all()
+      {
+        //lock_block<mt_policy> lock(this);
+        const_iterator it = m_senders.begin();
+        const_iterator itEnd = m_senders.end();
+
+        while(it != itEnd)
+        {
+          (*it)->slot_disconnect(this);
+          ++it;
+        }
+
+        m_senders.erase(m_senders.begin(), m_senders.end());
+      }
+
+    private:
+      sender_set m_senders;
+  };
+}
+
+#endif /* SLOT_H__ */
Index: trunk/src/lib/util/substring.cc
===================================================================
--- trunk/src/lib/util/substring.cc	(revision 9391)
+++ trunk/src/lib/util/substring.cc	(revision 9406)
@@ -28,8 +28,4 @@
 #include "substring.h"
 
-#include <string.h>
-#include <cassert>
-
-
 /**
  * @brief default constructor
@@ -108,5 +104,5 @@
 
 /** @brief An empty String */
-const std::string SubString::emptyString = "";
+// const std::string SubString::emptyString = "";
 /** @brief Helper that gets you a String consisting of all White Spaces */
 const std::string SubString::WhiteSpaces = " \n\t";
@@ -238,5 +234,8 @@
   }
   else
-    return SubString::emptyString;
+  {
+    static std::string empty;
+    return empty;
+  }
 }
 
@@ -250,5 +249,5 @@
  * SubString::SubString(const SubString& subString, unsigned int subSetBegin)
  */
-SubString SubString::getSubSet(unsigned int subSetBegin) const
+SubString SubString::subSet(unsigned int subSetBegin) const
 {
   return SubString(*this, subSetBegin);
@@ -265,5 +264,5 @@
  * SubString::SubString(const SubString& subString, unsigned int subSetBegin)
  */
-SubString SubString::getSubSet(unsigned int subSetBegin, unsigned int subSetEnd) const
+SubString SubString::subSet(unsigned int subSetBegin, unsigned int subSetEnd) const
 {
   return SubString(*this, subSetBegin, subSetEnd);
@@ -289,6 +288,4 @@
  * Supports delimiters, escape characters,
  * ignores special  characters between safemode_char and between comment_char and linend '\n'.
- *
- *
  */
 SubString::SPLIT_LINE_STATE
Index: trunk/src/lib/util/substring.h
===================================================================
--- trunk/src/lib/util/substring.h	(revision 9391)
+++ trunk/src/lib/util/substring.h	(revision 9406)
@@ -2,8 +2,22 @@
  * @file substring.h
  * @brief a small class to get the parts of a string separated by commas
+ *
+ * This class is also identified as a Tokenizer. It splits up one long
+ * String into multiple small ones by a designated Delimiter.
+ *
+ * Substring is Advanced, and it is possible, to split a string by ','
+ * but also removing leading and trailing spaces around the comma.
+ *
+ * @example
+ * Split the String std::string st = "1345, The new empire   , is , orxonox"
+ * is splitted with:
+ * SubString(st, ',', " \n\t")
+ * into
+ * "1345", "The new empire", "is", "orxonox"
+ * As you can see, the useless spaces around ',' were removed.
  */
 
-#ifndef _SUBSTRING_H
-#define _SUBSTRING_H
+#ifndef __SUBSTRING_H__
+#define __SUBSTRING_H__
 
 #include <vector>
@@ -61,6 +75,6 @@
 
   // retrieve a SubSet from the String
-  SubString getSubSet(unsigned int subSetBegin) const;
-  SubString getSubSet(unsigned int subSetBegin, unsigned int subSetEnd) const;
+  SubString subSet(unsigned int subSetBegin) const;
+  SubString subSet(unsigned int subSetBegin, unsigned int subSetEnd) const;
 
   // retrieve Information from within
@@ -70,7 +84,13 @@
   inline unsigned int size() const { return this->strings.size(); };
   /** @param i the i'th String @returns the i'th string from the subset of Strings */
-  inline const std::string& operator[](unsigned int i) const { return (i < this->strings.size()) ? this->strings[i] : emptyString; };
+  inline const std::string& operator[](unsigned int i) const { return this->strings[i]; };
   /** @param i the i'th String @returns the i'th string from the subset of Strings */
   inline const std::string& getString(unsigned int i) const { return (*this)[i]; };
+  /** @returns the front of the StringList. */
+  inline const std::string& front() const { return this->strings.front(); };
+  /** @returns the back of the StringList. */
+  inline const std::string& back() const { return this->strings.back(); };
+  /** @brief removes the back of the strings list. */
+  inline void pop_back() { this->strings.pop_back(); };
 
   // the almighty algorithm.
@@ -93,7 +113,5 @@
 private:
   std::vector<std::string>  strings;                      //!< strings produced from a single string splitted in multiple strings
-
-  static const std::string emptyString;
 };
 
-#endif /* _SUBSTRING_H */
+#endif /* __SUBSTRING_H__ */
Index: trunk/src/lib/util/threading.cc
===================================================================
--- trunk/src/lib/util/threading.cc	(revision 9391)
+++ trunk/src/lib/util/threading.cc	(revision 9406)
@@ -18,5 +18,5 @@
 #include "threading.h"
 
-using namespace std;
+
 
 namespace OrxThread
Index: trunk/src/orxonox.cc
===================================================================
--- trunk/src/orxonox.cc	(revision 9391)
+++ trunk/src/orxonox.cc	(revision 9406)
@@ -58,4 +58,5 @@
 
 #include "network_manager.h"
+#include "shared_network_data.h"
 
 #include "state.h"
@@ -66,5 +67,5 @@
 int verbose = 5;
 
-using namespace std;
+
 
 SHELL_COMMAND(restart, Orxonox, restart);
@@ -72,5 +73,6 @@
 REGISTER_ARG_FLAG( l, license,    "misc",  "showLicenseAndExit", "Prints the license and exit",      "1" );
 REGISTER_ARG_FLAG( c, client,     "game",  "gameType",           "Connect to Server (-H)",           "multiplayer_client" );
-REGISTER_ARG_FLAG( s, server,     "game",  "gameType",           "Start Orxonox as Game Server",     "multiplayer_server" );
+REGISTER_ARG_FLAG( s, server,     "game",  "gameType",           "Start Orxonox as Game Server",     "multiplayer_master_server" );
+REGISTER_ARG_FLAG( x, proxy,      "game",  "gameType",           "Start Orxonox as Proxy Server",    "multiplayer_proxy_server" );
 REGISTER_ARG_ARG(  H, host,       "game",  "host",               "Host to connect to",               "host");
 REGISTER_ARG_ARG(  p, port,       "game",  "port",               "Port to use",                      "port" );
@@ -79,5 +81,6 @@
 REGISTER_ARG_FLAG( f, fullscreen, "video", "Fullscreen-mode",    "start Orxonox in fullscreen mode", "1");
 REGISTER_ARG_FLAG( w, windowed,   "video", "Fullscreen-mode",    "start Orxonox in windowed mode",   "0");
-REGISTER_ARG_ARG(  r, resolution, "video", "Resolution",         "Sets resolution / window size",    "res");
+REGISTER_ARG_ARG(  r, resolution, "video", "Resolution",         "sets resolution / window size",    "res");
+REGISTER_ARG_FLAG( d, dedicated,  "video", "Norender-mode",      "the scene is not rendered",        "1" );
 
 REGISTER_ARG_FLAG( a, audio,      "audio", "Disable-Audio",      "Enable audio",                     "0" );
@@ -144,5 +147,5 @@
   SDL_QuitSubSystem(SDL_INIT_TIMER);
   ClassList::debug();
-  
+
   Preferences::getInstance()->save();
 
@@ -301,16 +304,28 @@
 {
   PRINT(3)("> Initializing networking\n");
-
-  if( this->serverName != "") // we are a client
-  {
+  std::string gameType = Preferences::getInstance()->getString( "game", "gameType", "" );
+
+  if( gameType == "multiplayer_client")
+  {    // we are a client
     State::setOnline(true);
-    NetworkManager::getInstance()->establishConnection(this->serverName, port);
-  }
-  else if( this->port > 0)
-  {    // we are a server
+    SharedNetworkData::getInstance()->setNodeType(NET_CLIENT);
+    NetworkManager::getInstance()->createClient(this->serverName, port);
+  }
+  else if( gameType == "multiplayer_master_server")
+  {    // we are a master server
     State::setOnline(true);
-    NetworkManager::getInstance()->createServer(port);
-  }
-  return 0;
+    SharedNetworkData::getInstance()->setNodeType(NET_MASTER_SERVER);
+
+    NetworkManager::getInstance()->createMasterServer(port);
+  }
+  else if( gameType == "multiplayer_proxy_server")
+  {    // we are a proxy server
+    State::setOnline(true);
+    SharedNetworkData::getInstance()->setNodeType(NET_PROXY_SERVER_ACTIVE);
+    NetworkManager::getInstance()->createProxyServer(port);
+  }
+
+  return 0;
+
 }
 
@@ -453,11 +468,12 @@
   if ( Preferences::getInstance()->getString("misc", "bt-to-file", "1") == "1" )
   {
-    SignalHandler::getInstance()->doCatch( argv[0] );
-
+    SignalHandler::getInstance()->doCatch( argv[0], "orxonox.backtrace" );
+    SignalHandler::getInstance()->registerCallback( EventHandler::releaseMouse, NULL );
   }
 
   if( Preferences::getInstance()->getString("game", "showGui", "") == "1" )
     showGui = true;
-  else if( Preferences::getInstance()->getString( "game", "gameType", "" ) == "multiplayer_server" ||
+  else if( Preferences::getInstance()->getString( "game", "gameType", "" ) == "multiplayer_master_server" ||
+           Preferences::getInstance()->getString( "game", "gameType", "" ) == "multiplayer_proxy_server" ||
            Preferences::getInstance()->getString( "game", "gameType", "" ) == "multiplayer_client" )
     return startNetworkOrxonox(argc, argv);
@@ -493,9 +509,17 @@
     startOrxonox(argc, argv, host.c_str(), port);
   }
-  else if ( gameType == "multiplayer_server" )
+  else if ( gameType == "multiplayer_master_server" )
   {
     int port = Preferences::getInstance()->getInt( "game", "port", DEFAULT_ORXONOX_PORT );
 
     printf("Starting Orxonox as server: listening on port %i\n", port);
+
+    startOrxonox(argc, argv, "", port);
+  }
+  else if ( gameType == "multiplayer_proxy_server" )
+  {
+    int port = Preferences::getInstance()->getInt( "game", "port", DEFAULT_ORXONOX_PORT );
+
+    printf("Starting Orxonox as proxy server: listening on port %i\n", port);
 
     startOrxonox(argc, argv, "", port);
Index: trunk/src/proto/proto_class.cc
===================================================================
--- trunk/src/proto/proto_class.cc	(revision 9391)
+++ trunk/src/proto/proto_class.cc	(revision 9406)
@@ -18,5 +18,5 @@
 #include "proto_class.h"
 
-using namespace std;
+
 
 
Index: trunk/src/proto/proto_singleton.cc
===================================================================
--- trunk/src/proto/proto_singleton.cc	(revision 9391)
+++ trunk/src/proto/proto_singleton.cc	(revision 9406)
@@ -18,5 +18,5 @@
 #include "proto_singleton.h"
 
-using namespace std;
+
 
 
Index: trunk/src/proto/proto_world_entity.cc
===================================================================
--- trunk/src/proto/proto_world_entity.cc	(revision 9391)
+++ trunk/src/proto/proto_world_entity.cc	(revision 9406)
@@ -16,5 +16,5 @@
 #include "proto_world_entity.h"
 
-using namespace std;
+
 
 
Index: trunk/src/story_entities/Makefile.am
===================================================================
--- trunk/src/story_entities/Makefile.am	(revision 9391)
+++ trunk/src/story_entities/Makefile.am	(revision 9406)
@@ -13,5 +13,4 @@
 		story_entities/multi_player_world_data.cc \
 		story_entities/movie_loader.cc \
-		story_entities/simple_game_menu.cc \
 		\
 		story_entities/menu/game_menu.cc \
@@ -30,5 +29,4 @@
 		story_entities/multi_player_world_data.h \
 		story_entities/movie_loader.h \
-		story_entities/simple_game_menu.h \
 		\
 		story_entities/menu/game_menu.h \
Index: trunk/src/story_entities/campaign.cc
===================================================================
--- trunk/src/story_entities/campaign.cc	(revision 9391)
+++ trunk/src/story_entities/campaign.cc	(revision 9406)
@@ -25,5 +25,5 @@
 #include "campaign_data.h"
 
-using namespace std;
+
 
 
Index: trunk/src/story_entities/campaign_data.cc
===================================================================
--- trunk/src/story_entities/campaign_data.cc	(revision 9391)
+++ trunk/src/story_entities/campaign_data.cc	(revision 9406)
@@ -23,5 +23,5 @@
 
 
-using namespace std;
+
 
 
@@ -103,5 +103,5 @@
   int                            nextStoryID;
   int                            storyID;
-  list<StoryEntity*>::iterator   it;
+  std::list<StoryEntity*>::iterator   it;
 
   nextStoryID = 0;
@@ -124,5 +124,5 @@
   int                            nextStoryID;
   int                            storyID;
-  list<StoryEntity*>::iterator   it;
+  std::list<StoryEntity*>::iterator   it;
 
   nextStoryID = this->currentEntity->getNextStoryID();
@@ -145,5 +145,5 @@
 StoryEntity* CampaignData::getLevel(int storyID)
 {
-  list<StoryEntity*>::iterator   it;
+  std::list<StoryEntity*>::iterator   it;
   for( it = this->storyEntities.begin(); it != this->storyEntities.end(); it++)
   {
Index: trunk/src/story_entities/dedicated_server_world.cc
===================================================================
--- trunk/src/story_entities/dedicated_server_world.cc	(revision 9391)
+++ trunk/src/story_entities/dedicated_server_world.cc	(revision 9406)
@@ -28,5 +28,5 @@
 
 
-using namespace std;
+
 
 //! This creates a Factory to fabricate a DedicatedServerWorld
Index: trunk/src/story_entities/game_world.cc
===================================================================
--- trunk/src/story_entities/game_world.cc	(revision 9391)
+++ trunk/src/story_entities/game_world.cc	(revision 9406)
@@ -512,8 +512,13 @@
 void GameWorld::display ()
 {
+
+    // if this server is a dedicated server the game workd does not need to be drawn
+  if( !GraphicsEngine::getInstance()->isDedicated())
+  {
   // render the reflection texture
   this->renderPassReflection();
   // redner the refraction texture
   this->renderPassRefraction();
+  }
   // render all
   this->renderPassAll();
@@ -643,29 +648,33 @@
   LightManager::getInstance()->draw();
 
-  /* Draw the BackGround */
-  this->drawEntityList(State::getObjectManager()->getObjectList(OM_BACKGROUND));
-  engine->drawBackgroundElements();
-
-  /* draw all WorldEntiy groups */
-  for (unsigned int i = 0; i < this->dataTank->drawLists.size(); ++i)
-    this->drawEntityList(State::getObjectManager()->getObjectList(this->dataTank->drawLists[i]));
-
-  AtmosphericEngine::getInstance()->draw();
-
-  if( unlikely( this->showBV))
-  {
-    CDEngine* engine = CDEngine::getInstance();
+  // only render the world if its not dedicated mode
+  if( !GraphicsEngine::getInstance()->isDedicated())
+  {
+    /* Draw the BackGround */
+    this->drawEntityList(State::getObjectManager()->getObjectList(OM_BACKGROUND));
+    engine->drawBackgroundElements();
+
+    /* draw all WorldEntiy groups */
     for (unsigned int i = 0; i < this->dataTank->drawLists.size(); ++i)
-      engine->drawBV(State::getObjectManager()->getObjectList(this->dataTank->drawLists[i]), this->showBVLevel);
-  }
-
-  if( unlikely(this->showPNodes))
-    PNode::getNullParent()->debugDraw(0);
+      this->drawEntityList(State::getObjectManager()->getObjectList(this->dataTank->drawLists[i]));
+
+    AtmosphericEngine::getInstance()->draw();
+
+    if( unlikely( this->showBV))
+    {
+      CDEngine* engine = CDEngine::getInstance();
+      for (unsigned int i = 0; i < this->dataTank->drawLists.size(); ++i)
+        engine->drawBV(State::getObjectManager()->getObjectList(this->dataTank->drawLists[i]), this->showBVLevel);
+    }
+
+    if( unlikely(this->showPNodes))
+      PNode::getNullParent()->debugDraw(0);
+
+    // draw the game ruls
+    if( likely(this->dataTank->gameRule != NULL))
+      this->dataTank->gameRule->draw();
+  }
 
   engine->draw();
-
-  // draw the game ruls
-  if( likely(this->dataTank->gameRule != NULL))
-    this->dataTank->gameRule->draw();
 }
 
Index: trunk/src/story_entities/game_world_data.cc
===================================================================
--- trunk/src/story_entities/game_world_data.cc	(revision 9391)
+++ trunk/src/story_entities/game_world_data.cc	(revision 9406)
@@ -61,5 +61,5 @@
 
 
-using namespace std;
+
 
 
@@ -194,5 +194,8 @@
 ErrorMessage GameWorldData::loadWorldEntities(const TiXmlElement* root)
 {
+
   const TiXmlElement* element = root->FirstChildElement("WorldEntities");
+  bool mouseCaptured = EventHandler::getInstance()->grabbedEvents();
+  EventHandler::getInstance()->grabEvents(false);
 
   if( element == NULL)
@@ -209,5 +212,5 @@
       BaseObject* created = Factory::fabricate(element);
       if( created != NULL )
-        PRINTF(4)("Created a %s: %s\n", created->getClassName(), created->getName());
+        PRINTF(4)("Created a %s: %s\n", created->getClassCName(), created->getCName());
 
       //todo do this more elegant
@@ -233,5 +236,5 @@
 
   Playable* playable;
-  const list<BaseObject*>* playableList = ClassList::getList(CL_PLAYABLE);
+  const std::list<BaseObject*>* playableList = ClassList::getList(CL_PLAYABLE);
   if (playableList != NULL && !playableList->empty())
   {
@@ -262,4 +265,6 @@
   /* init the pnode tree */
   PNode::getNullParent()->init();
+
+  EventHandler::getInstance()->grabEvents(mouseCaptured);
 
   return ErrorMessage();
@@ -284,5 +289,5 @@
       //    ClassList::debug( 3, CL_PARENT_NODE);
       //    PNode::getNullParent()->debugNode(0);
-      //    printf("%s::%s\n", nodeList->front()->getClassName(), nodeList->front()->getName());
+      //    printf("%s::%s\n", nodeList->front()->getClassCName(), nodeList->front()->getName());
       delete nodeList->front();
     }
Index: trunk/src/story_entities/menu/game_menu.cc
===================================================================
--- trunk/src/story_entities/menu/game_menu.cc	(revision 9391)
+++ trunk/src/story_entities/menu/game_menu.cc	(revision 9406)
@@ -152,14 +152,14 @@
     {
       OrxGui::GLGuiButton* startButton = new OrxGui::GLGuiPushButton("Play");
-      startButton->connect(SIGNAL(startButton, released), this, SLOT(GameMenu, showCampaigns));
+      startButton->released.connect(this, &GameMenu::showCampaigns);
       this->mainMenuBox->pack(startButton);
       startButton->select();
 
       OrxGui::GLGuiButton* networkButton = new OrxGui::GLGuiPushButton("MultiPlayer");
-      networkButton->connect(SIGNAL(networkButton, released), this, SLOT(GameMenu, showMultiPlayer));
+      networkButton->released.connect(this, &GameMenu::showMultiPlayer);
       this->mainMenuBox->pack(networkButton);
 
       OrxGui::GLGuiButton* optionsButton = new OrxGui::GLGuiPushButton("Options");
-      optionsButton->connect(SIGNAL(optionsButton, released), this, SLOT(GameMenu, showOptionsMenu));
+      optionsButton->released.connect(this, &GameMenu::showOptionsMenu);
       this->mainMenuBox->pack(optionsButton);
 
@@ -167,5 +167,5 @@
       OrxGui::GLGuiButton* quitButton = new OrxGui::GLGuiPushButton("Quit");
       this->mainMenuBox->pack(quitButton);
-      quitButton->connect(SIGNAL(quitButton, released), this, SLOT(GameMenu, quitMenu));
+      quitButton->released.connect(this, &GameMenu::quitMenu);
     }
   }
@@ -202,5 +202,5 @@
           printf("%s\n", se->getMenuScreenshoot().c_str());
           OrxGui::GLGuiImageButton* button = new OrxGui::GLGuiImageButton(se->getName(), se->getStoryID(), se->getMenuScreenshoot(), image);
-          button->connect(SIGNAL(button, startLevel), this, SLOT(GameMenu, startLevel));
+          button->startLevel.connect(this, &GameMenu::startLevel);
           labelBox->pack(button);
 
@@ -244,9 +244,9 @@
       OrxGui::GLGuiButton* clientButton = new OrxGui::GLGuiPushButton("Client");
       box->pack(clientButton);
-      clientButton->connect(SIGNAL(clientButton, released), this, SLOT(GameMenu, showClientMenu));
+      clientButton->released.connect(this, &GameMenu::showClientMenu);
 
       OrxGui::GLGuiButton* serverButton = new OrxGui::GLGuiPushButton("Server");
       box->pack(serverButton);
-      serverButton->connect(SIGNAL(serverButton, released), this, SLOT(GameMenu, showServerMenu));
+      serverButton->released.connect(this, &GameMenu::showServerMenu);
 
       networkBox->pack( box );
@@ -531,10 +531,10 @@
       this->ipInputLine->setText( Preferences::getInstance()->getString( "multiplayer", "lastVisitedServer", "localhost" ) );
       this->clientNetworkBox->pack( this->ipInputLine );
-      this->ipInputLine->connect(SIGNAL(ipInputLine, enterPushed), this, SLOT(GameMenu, connectToServer));
+      //this->ipInputLine->enterPushed.connect(this, &GameMenu::connectToServer); /// redo this.
       this->ipInputLine->select();
 
       OrxGui::GLGuiButton* connectButton = new OrxGui::GLGuiPushButton("Connect");
       clientNetworkBox->pack(connectButton);
-      connectButton->connect(SIGNAL(connectButton, released), this, SLOT(GameMenu, connectToServer));
+      connectButton->released.connect(this, &GameMenu::connectToServer);
     }
   }
@@ -574,5 +574,5 @@
       OrxGui::GLGuiButton* createButton = new OrxGui::GLGuiPushButton("Create Server");
       serverNetworkBox->pack(createButton);
-      createButton->connect(SIGNAL(createButton, released), this, SLOT(GameMenu, createServer));
+      createButton->released.connect(this, &GameMenu::createMasterServer);
     }
   }
@@ -593,5 +593,5 @@
 
   State::setOnline(true);
-  NetworkManager::getInstance()->establishConnection( this->ipInputLine->_getText(), 9999 );
+  NetworkManager::getInstance()->createClient( this->ipInputLine->_getText(), 9999 );
 
   Preferences::getInstance()->setString( "multiplayer", "lastVisitedServer", this->ipInputLine->_getText() );
@@ -600,10 +600,10 @@
 }
 
-void GameMenu::createServer( )
+void GameMenu::createMasterServer( )
 {
   PRINTF(0)("Create server\n" );
 
   State::setOnline(true);
-  NetworkManager::getInstance()->createServer( 9999 );
+  NetworkManager::getInstance()->createMasterServer( 9999 );
 
   this->startLevel( 5 );
Index: trunk/src/story_entities/menu/game_menu.h
===================================================================
--- trunk/src/story_entities/menu/game_menu.h	(revision 9391)
+++ trunk/src/story_entities/menu/game_menu.h	(revision 9406)
@@ -50,5 +50,5 @@
     
     void showServerMenu();
-    void createServer();
+    void createMasterServer();
 
 
Index: trunk/src/story_entities/menu/glgui_imagebutton.cc
===================================================================
--- trunk/src/story_entities/menu/glgui_imagebutton.cc	(revision 9391)
+++ trunk/src/story_entities/menu/glgui_imagebutton.cc	(revision 9406)
@@ -40,5 +40,5 @@
     GLGuiPushButton::releasing(pos, focused);
     if (focused)
-      this->emit(startLevel(this->levelID));
+      this->startLevel.emit(this->levelID);
   }
 
@@ -77,5 +77,5 @@
       {
 //        emit(released());
-        emit(startLevel(this->levelID));
+        startLevel.emit(this->levelID);
       }
       return true;
Index: trunk/src/story_entities/menu/glgui_imagebutton.h
===================================================================
--- trunk/src/story_entities/menu/glgui_imagebutton.h	(revision 9391)
+++ trunk/src/story_entities/menu/glgui_imagebutton.h	(revision 9406)
@@ -25,5 +25,5 @@
     void release();
 
-    DeclareSignal1(startLevel, int);
+    sigslot::signal1<int> startLevel;
 
   protected:
Index: trunk/src/story_entities/movie_loader.cc
===================================================================
--- trunk/src/story_entities/movie_loader.cc	(revision 9391)
+++ trunk/src/story_entities/movie_loader.cc	(revision 9406)
@@ -24,5 +24,5 @@
 
 
-using namespace std;
+
 
 CREATE_FACTORY(MovieLoader, CL_MOVIE_LOADER);
Index: trunk/src/story_entities/multi_player_world.cc
===================================================================
--- trunk/src/story_entities/multi_player_world.cc	(revision 9391)
+++ trunk/src/story_entities/multi_player_world.cc	(revision 9406)
@@ -31,6 +31,5 @@
 
 
-using namespace std;
-
+#include "glgui_handler.h"
 
 //! Register a command to print some multiplayer world infos
@@ -64,4 +63,5 @@
   if( this->dataTank)
     delete this->dataTank;
+  delete OrxGui::GLGuiHandler::getInstance( );
 }
 
